#!/usr/bin/perl -w

use strict;

# pamcalendar v1.0.2 - erstellt und konvertiert Arbeitszeitdaten fr PameLa
# Copyright (C) 2001, 2002 Dirk Swiniartzki (pamela@planet-dirk.de)
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License version 2
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#    General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#    -----------------------------------------------------------
#    Dieses Programm ist freie Software. Sie knnen es unter
#    den Bedingungen der GNU General Public License Version 2,
#    wie von der Free Software Foundation herausgegeben, weitergeben
#    und/oder modifizieren.
#
#    Die Verffentlichung dieses Programms erfolgt in der
#    Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE JEDE
#    GEWHRLEISTUNG - sogar ohne die implizite Gewhrleistung
#    der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN ZWECK.
#    Details finden Sie in der GNU General Public License.
#
#    Sie sollten eine Kopie der GNU General Public License zusammen
#    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
#    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
#    MA 02139, USA.
#    ----------------------------------------------------------------

my ($a, $b, $c);      # temporre Variablen

#---------- generate_calendar ----------
# generiert eine Kalenderdatei
# Parameter : -
# Rckgabewerte : -

sub generate_calendar {
    my ($a, $b, $c);          # temporre Variablen
    my $file;                 # Dateiname
    my $systems;              # Anzahl Arbeitssysteme
    my ($start, $end);        # Start- und Enddatum
    my ($day, $month, $year); # aktueller Tag, Monat, Jahr
    my @months1=(0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
    my @months2=(0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30 ,31);

    print "\nName der Kalenderdatei ? ";
    $file=<STDIN>;
    chomp($file);
    do {
        $a="n";
        print "Startdatum ([t]t.[m]m.jjjj) ? ";
        $start=<STDIN>;
    chomp($start);
        unless ($start=~/\d{1,2}\.\d{1,2}\.\d{4}/) {
            print "$start ist keine gltige Datumsangabe !";
            $a="j";}}
        until ($a="n");
    do {
        $a="n";
        print "Enddatum   ([t]t.[m]m.jjjj) ? ";
        $end=<STDIN>;
        chomp($end);
        unless ($end=~/\d{1,2}\.\d{1,2}\.\d{4}/) {
            print "$end ist keine gltige Datumsangabe !";
            $a="j";}}
        until ($a="n");
    print "Name der Datei mit der Arbeitssystem-Liste ? ";
    $systems=<STDIN>;
    chomp($systems);
    unless (-e $systems) {
        print "Die Datei $systems existiert nicht !\n";
	die;}
    print "\n";

    open(FILE, ">$file") || die("Konnte Datei $file nicht ffnen : $!\n");
    open(INPUT, $systems) || die("Konnte Datei $systems nicht ffnen : $!\n");

    while($c=<INPUT>) {
        chomp($c);
        print "Bearbeite Arbeitssystem $c\n";
        print FILE "Arbeitssystem;$c\n";
        print FILE "Datum;Arbeitsbeginn;Arbeitsende\n";
        $start=~/(\d{1,2})\.(\d{1,2})\.(\d{4})/; # Regex fr Datum der Form t[t].m[m].jjjj
        $day=$1;
        $month=$2;
        $year=$3;
        do {
            $a="$day.$month.$year";
            print FILE "$a;8:00;16:00\n";
            $day++;
            if ((($year % 4) == 0 && ($year % 100) != 0) || ($year % 400) == 0) { # Schaltjahr ?
                if ($day>$months2[$month]) {
                    $day=1;
                    $month++}}
            else {
                if ($day>$months1[$month]) {
                    $day=1;
                    $month++;}}
            if ($month>12) {
                $month=1;
                $year++;}
            } until ($a eq $end);
        print FILE "\n";}
    close(FILE);
    close(INPUT);
    print "Kalenderdatei $file erzeugt.\n\n";
    #print "Bitte ndern Sie in der Angabe \"Arbeitssystem xxx\" xxx in die entsprechenden Arbeitsplatznummer.\n\n";
}

#---------- convert_calendar ----------
# konvertiert eine Kalenderdatei in eine Arbeitszeitdatei
# Parameter : -
# Rckgabewerte : -

sub convert_calendar {
    my ($a, $b, $c);  # temporre Variablen
    my $file;        # Dateiname Kalenderdatei
    my $filenew;     # Dateiname der Arbeitszeitdatei

    do {
        $a="n";
        print "\nName der zu konvertierenden Kalenderdatei ? ";
        $file=<STDIN>;
        chomp($file);
        unless (-e $file) {
            print "Datei $file exisitiert nicht !\n";
            $a="j";}}
        until ($a="n");
    print "Name der zu erstellenden Arbeitszeitdatei ? ";
    $filenew=<STDIN>;
    chomp($filenew);

    open(INPUT, $file) || die("Konnte Datei $file nicht ffnen : $!\n");
    open(OUTPUT, ">$filenew") || die("Konnte Datei $filenew nicht anlegen : $!\n");
    while (<INPUT>) {
        chomp;
        next unless ($_);       # leere Zeile - Skip
        if (/^Arbeitssystem/) { # Angabe des Arbeitssystems, also neue Zeile anfangen
            s/Arbeitssystem;//;
	    while (/;/) { s/;//;}
            print OUTPUT "\n$_";
	    next;}
        next if (/^Datum;/);    # Tebellenkopf, bergehen
        ($a, $b, $c)=split(/;/); #/ # Jetzt die Arbeitszeitangaben verarbeiten
        print OUTPUT ";$b;$c";}
    close(INPUT);
    close(OUTPUT);
    print "\nDatei $file konvertiert. Neuer Dateiname : $filenew\n\n";
}

#---------- Hauptprogramm ----------
print <<ANNOUNCE;
pamcalendar v1.0.2 - erzeugt und konvertiert Arbeitszeitdatenfr PameLa
Copyright (C) 2001, 2002 Dirk Swiniartzki pamela\@planet-dirk.de

Dieses Programm ist freie Software. Sie knnen es unter
den Bedingungen der GNU General Public License Version 2,
wie von der Free Software Foundation herausgegeben, weitergeben
und/oder modifizieren.

Die Verffentlichung dieses Programms erfolgt in der
Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE JEDE
GEWHRLEISTUNG - sogar ohne die implizite Gewhrleistung
der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
ANNOUNCE

print "\nSyntax : pamcalendar.plx\n\n";
do {
    print "----------------------------------------------------------------------\n";
    print "e - Kalenderdatei erzeugen\n";
    print "k - Kalenderdatei in Arbeitszeitdatei konvertieren\n";
    print "q - Ende\n";
    print "Ihre Wahl ? ";
    $a=<STDIN>;
    chomp($a);
    if ($a eq "e") { generate_calendar();}
    if ($a eq "k") { convert_calendar();}}
    until ($a eq "q");

__END__
